% CoMa2 - SS11
% Aufg.2.3(a)
function y = evallagrangepoly(x,f,z)
% Diese Funktion wertet ein Interpolationspolynom in Lagrange-Darstellung
% an beliebigen Stellen aus

% Inputs: Vektor x mit St�tzstellen, Vektor f mit Werten an den
% St�tzstellen, Vektor z mit Stellen, an denen das Interpolationspolynom
% ausgewertet werden soll

% Outputs: Vektor y mit den Werten des Interpolationspolynoms an den
% Stellen z

% (Warum nur beginnt MATLAB mit 1 beim "Indicieren"?)
n = length(x) - 1;      % (n+1) ist die Anzahl der St�tzstellen
L = ones(n+1,length(z));   % Initialisierung der Lagrange-Polynome

for i=0:n
    for k=0:n
        if i~=k
            L(k+1,:) = L(k+1,:) .* (z - x(i+1)) ./ (x(k+1) - x(i+1));
        end
    end
end

p = zeros(length(z),1);
f = f(:)';      % f soll auf jeden Fall ein Zeilenvektor sein

for j=1:length(z)
    p(j) = f * L(:,j);
end

% fertig...
y = p;