% CoMa2 - SS11
% Aufg.2.3(b),(c)

% Testlufe, Plots, ...

clear all

I = -3:0.01:3;

% probieren wir mal...
n = [50 100 150];

c = 'cbk';	% Farben der Graphen

%% Teil(b)

figure(1);
% wir plotten auch exp auf I
subplot(2,2,1);
plot(I,exp(I),'r');
title('exp(I)');    

for j=1:length(n)
    % quidistante Knoten
    subplot(2,2,j+1);
    x_aq = -3:6/n(j):3;
    f_aq = exp(x_aq);
    p_aq = evallagrangepoly(x_aq,f_aq,I);
    % Plot des Interpolatiospolynoms
    plot(I,p_aq,c(j));
    title(['quidt.St. n = ' num2str(n(j))]);
end

figure(2);
% wir plotten auch exp auf I
subplot(2,2,1);
plot(I,exp(I),'r');
title('exp(I)');    

for j=1:length(n)
    % Tschebyscheff-Knoten
    subplot(2,2,j+1);
    x_ts = 1:2:2*n(j)+1;
    x_ts = 3*cos(x_ts * pi./(2*n(j)+2));
    f_ts = exp(x_ts);
    p_ts = evallagrangepoly(x_ts,f_ts,I);
    % Plot des Interpolatiospolynoms
    plot(I,p_ts,c(j));
    title(['Tscheby.St. n = ' num2str(n(j))]);
end

%% Teil(c): ein Funktionswert wird gestrt

figure(3);
% wir plotten auch exp auf I
subplot(2,2,1);
plot(I,exp(I),'r');
title('exp(I)');    

for j=1:length(n)
    % quidistante Knoten
    subplot(2,2,j+1);
    x_aq = -3:6/n(j):3;
    f_aq = exp(x_aq);
    % wir stren den Funktionswert an der mittleren Sttzstelle
    f_aq(floor(n(j)/2)) = f_aq(floor(n(j)/2)) - 0.01;
    p_aq = evallagrangepoly(x_aq,f_aq,I);
    % Plot des Interpolatiospolynoms
    plot(I,p_aq,c(j));
    title(['quidt.St. n = ' num2str(n(j))]);
end

figure(4);
% wir plotten auch exp auf I
subplot(2,2,1);
plot(I,exp(I),'r');
title('exp(I)');    

for j=1:length(n)
    % Tschebyscheff-Knoten
    subplot(2,2,j+1);
    x_ts = 1:2:2*n(j)+1;
    x_ts = 3*cos(x_ts * pi./(2*n(j)+2));
    f_ts = exp(x_ts);
    % wir stren den Funktionswert an der mittleren Sttzstelle
    f_ts(floor(n(j)/2)) = f_ts(floor(n(j)/2)) - 0.01;
    p_ts = evallagrangepoly(x_ts,f_ts,I);
    % Plot des Interpolatiospolynoms
    plot(I,p_ts,c(j));
    title(['Tscheby.St. n = ' num2str(n(j))]);
end